package jrummikub.util;

/**
 * Interface for classes that can generate events having a two parameters
 * 
 * @param <T1>
 *            type of the first event parameter
 * @param <T2>
 *            type of the second event parameter
 * @param <T3>
 *            type of third event parameter
 */
public interface IEvent3<T1, T2, T3> {
	/**
	 * Start to publish all events to a given listener
	 * 
	 * @param listener
	 *            target listener
	 * @return a connection to remove the listener
	 */
	public Connection add(IListener3<T1, T2, T3> listener);

	/**
	 * Stop publishing events to a given listener
	 * 
	 * @param listener
	 *            target listener
	 */
	public void remove(IListener3<T1, T2, T3> listener);
}
